﻿// See https://aka.ms/new-console-template for more information

Message msg = new Message();

// 컴파일 오류 발생
// error CS8926: A static abstract interface member can be accessed only on a type parameter.
// Console.WriteLine(IMessage.Any);

Console.WriteLine(Message.Any);

public interface IMessage
{
    public static int None = 0;

    // C# 9 이전에는 컴파일 오류 발생
    // error CS0112: A static member 'IMessage<T>.None' cannot be marked as override, virtual, or abstract
    public static abstract int Any { get; }

    static abstract void All();
}

public class Message : IMessage
{
    public static int Any => 5;

    public static void All()
    {
        Console.WriteLine("All called");
    }
}

public class Dispatcher<T> where T : IMessage
{
    public int GetAny() => T.Any;
}

interface IMy
{
    static abstract void M();
    static abstract IMy P { get; set; }
    static abstract event Action E;
    static abstract IMy operator +(IMy l, IMy r);
    static abstract bool operator ==(IMy l, IMy r);
    static abstract bool operator !=(IMy l, IMy r);

    /* 이하 2개의 컴파일 오류는 정상 오류 */
    // error CS0552: 'IMy.implicit operator IMy(string)': user-defined conversions to or from an interface are not allowed
    // static abstract implicit operator IMy(string s);

    // error CS0552: 'IMy.implicit operator string(IMy)': user-defined conversions to or from an interface are not allowed
    // static abstract implicit operator string(IMy s);

    static abstract bool operator !(IMy l);
}

interface IYour<T>
{
    static abstract void M();
    static abstract T P { get; set; }
    static abstract event Action E;

    /* 이하 6개의 컴파일 오류는 정상 오류 */
    // error CS8924: One of the parameters of a binary operator must be the containing type, or its type parameter constrained to it.
    // static abstract T operator +(T l, T r);

    // error CS8924: One of the parameters of a binary operator must be the containing type, or its type parameter constrained to it.
    // static abstract bool operator ==(T l, T r);

    // error CS8924: One of the parameters of a binary operator must be the containing type, or its type parameter constrained to it.
    // static abstract bool operator !=(T l, T r);

    // error CS8931: User-defined conversion in an interface must convert to or from a type parameter on the enclosing type constrained to the enclosing type
    // static abstract implicit operator T(string s);

    //  error CS8931: User-defined conversion in an interface must convert to or from a type parameter on the enclosing type constrained to the enclosing type
    // static abstract explicit operator string(T t);

    // error CS8921: The parameter of a unary operator must be the containing type, or its type parameter constrained to it.
    // static abstract bool operator !(T l);
}

interface ITheir<T> where T: ITheir<T>
{
    static abstract void M();
    static abstract T P { get; set; }
    static abstract T operator +(T l, T r);
    static abstract implicit operator T(string s);
    static abstract explicit operator string(T t);

    static abstract bool operator !(T l);
}

public class TheirClass : ITheir<TheirClass>
{
    public static TheirClass P { get => throw new NotImplementedException(); 
                                set => throw new NotImplementedException(); }

    public static void M() { }

    public static TheirClass operator +(TheirClass l, TheirClass r) => throw new NotImplementedException();
    public static implicit operator TheirClass(string s) => throw new NotImplementedException();
    public static explicit operator string(TheirClass t) => "type";
    public static bool operator !(TheirClass l) => true;
}

class YourClass<T> where T : ITheir<T>
{
    object Method()
    {
        return T.P;
    }
}